//
// gets data point values (col 1) and
// (optional) weights or sigmas (col 2).
// if col 2, there must be one for each data point value.
//

#include "meanvar.h"

extern int optind;

void get_data(ifstream& ifs, dvec& x, dvec& s)
{
  uns k;
  uns n;
  dbl z;                                        // will contain x or w or s
  string line;
  isstream iss;

  for (k = 1; getline(ifs, line); ++k) {
    trimspace(line);
    n = 0;
    iss.clear();                                      // clear state of iss
    iss.str(line);                                   // put the line in iss
    while (iss >> z) {               // while a double (or int) is detected
      ++n;                                // increment over numbers in line
      if (n==1) {
        x.push_back(z);                     // grow the x (x-values) vector
      }
      else if (n==2) {
        s.push_back(z);                // grow the s (wts or sigmas) vector
      }
      else {                                                       // n > 2
        err("too many entries in datafile at line no ", k);
      }
    }
    if ((s.size() != 0) && (s.size() != x.size())) {
      err("error in datafile near line no ", k);
    }
  }
}
