#include "config.h"                                  // for PACKAGE_VERSION
#include "meanvar.h"

//
// gets options from the command line
//

extern int optind;

void get_opts(int argc, char** argv, opts& o)
{
  extern int opterr;
  int k;
  int opt_index=0;
  o.ignore_s = no;
  o.weights = no;
  o.conf = 68.269;
  string pgname = basename(argv[0]);

  if (pgname.rfind(".exe") != string::npos) {
    pgname.replace(pgname.find(".exe"),4,"");
  }

  static struct option long_options[] = {
    {"help", 0, 0, 'h'},
    {"version", 0, 0, 'v'},
    {"ignore_s", 0, 0, 'i'},
    {"weights", 0, 0, 'w'},
    {"conf", 1, 0, 'c'},
    {0, 0, 0, 0}
  };

  opterr = yes;

  while ((k = getopt_long(argc, argv, "hviwc:",
          long_options, &opt_index)) != -1 ) {

    switch(k) {
      case 'h':
        prn_info(argv);
        exit(0);
        break;
      case 'v':
        cerr << "\n  " << pgname << " version "
             << PACKAGE_VERSION << "\n\n";
        exit(0);
        break;
      case 'i':
        o.ignore_s = yes;
        break;
      case 'w':
        o.weights = yes;
        break;
      case 'c':
        o.conf = atof(optarg);
        break;
      case '?':
        prn_usage(argv);
        exit(EXIT_FAILURE);
      default:
        error_exit_cannot_get_here(__FILE__, __LINE__);
    }
  }
}
