// Al Kelley's graceful versions
//
#include "meanvar.h"

void gopen(ifstream& ifs, const string fname)
{
  assert(ifs);
  assert(ifs.is_open() == false);
  ifs.open(fname.c_str());
  if (!ifs)
    err("cannot open ", fname);
}

// Here is the function prototype for strftime():
// size_t strftime(char* s, size_t max, const char* format, const struct tm* tm);

void gstrftime(string& s, const string fmt, const struct tm* info)
{
  cint n = fmt.length() + 80;
  char buf[n];
  if (strftime(buf, sizeof(buf), fmt.c_str(), info)) {
    s = buf;
  }
  else {                    // strftime returns 0 for some few format chars
    time_t now = time(NULL);
    s = ctime(&now);                          // but surely ctime will work
  }
}
