#include <algorithm>                          // for exit(), anything else?
#include <cassert>
#include <cmath>
#include <ctime>                                        // in prn_results()
#include <fstream>
#include <iomanip>
#include <iostream>
#include <libgen.h>                                       // for basename()
#include <limits>                                 // for gammq() and gser()
#include <sstream>
#include <vector>

#include <unistd.h>                                         // for getopt()
#include <getopt.h>                                 // for getopt(), again?

using namespace std;

typedef  const int      cint;
typedef  unsigned       uns;
typedef  double         dbl;
typedef  const double   cdbl;
typedef  const string   cstring;
typedef  istringstream  isstream;
typedef  ostringstream  osstream;
typedef  vector<dbl>    dvec;

enum no_yes {no, yes};

struct result {
    uns npts;                                      // number of data points
    uns n2;                                         // is there col 2 data?
    dbl mean;                                                // sample mean
    dbl var;                                             // sample variance
    dbl stddev;                                     // sample std deviation
    dbl smean;                                     // std deviation of mean
    dbl chisq;                                                // chi-square
    dbl alpha;                        // probability of a larger chi-square
    string datafile;
};

struct opts {
    int ignore_s;
    int weights;
    dbl conf;
};

// prototypes
//
void trimspace(string&);
void gopen(ifstream& ifs, cstring fname);
void err(cstring, cstring);
void err(cstring);
void warn(cstring);
void err(cstring, int);
void err(cstring, int, cstring);
void get_data(ifstream& ifs, dvec& x, dvec& s);         // x=value, s=sigma
void get_opts(int, char**, opts&);
void calculate(dvec& x, dvec& s, opts&, result&);
void prn_usage(char**);
void prn_info(char**);
void prn_results(result&, opts&);
dbl  factln(cint);
dbl  gammln(cdbl);
dbl  gammq(cdbl, cdbl);
// void gser(dbl&, cdbl, cdbl, dbl&);
// void gcf(dbl&, cdbl, cdbl, dbl&);
dbl gser(cdbl, cdbl);
dbl gcf(cdbl, cdbl);
cdbl pi();
dbl  norm(uns);
dbl  stud(dbl, uns);
dbl  student(uns, cdbl);

void  error_exit_cannot_get_here(cstring fname, cint line_no);
void  gstrftime(string& s, cstring format, const struct tm* tm);
