// ---
// Results get printed on the screen.  Redirect
// the output to a file if you want to keep it.
//

#include "meanvar.h"

void prn_results(result& r, opts& o)
{
  time_t now = time(NULL);
  string s = ctime(&now);                     // probably has \n at its end
  struct tm* info = localtime(&now);
  const string fmt = "  Results at %I:%M:%S %p on %A, %B %d, %Y:";

  string    t;
  osstream  oss;

//   if (s.rfind('\n') < string::npos) {               // check to make sure
//     s.erase(s.end()-1);                           // if so, get rid of it
//   }

//  gstrftime(t, "%H:%M on %A, %-d %B %Y", localtime(&now));
  gstrftime(t, fmt, info);

  const int  fw = (r.n2 && !o.weights) ? 31 : 23;            // field width

  cout << "\n" << t << "\n\n";

  oss.precision(4);
  cout.precision(4);
  oss << showpoint << r.mean << " +/- " << r.smean;
  cout << left
       << setw(fw) << "  data filename"         << " = " << r.datafile  << "\n"
       << setw(fw) << "  number of data points" << " = " << r.npts      << "\n"
       << setw(fw) << "  degrees of freedom"    << " = " << r.npts - 1  << "\n"
       << setw(fw) << "  sample mean"           << " = " << oss.str()   << "\n"
       << setw(fw) << "  sample variance"       << " = " << r.var       << "\n"
       << setw(fw) << "  sample std deviation"  << " = " << sqrt(r.var) << "\n";
  if ((r.n2 && o.weights)||(!r.n2 && !o.weights)){
  // conf level is relevant only for situations (a) or (b)
    cout << setw(fw) << "  confidence level" << " = " << o.conf << " percent"
         << endl;
  }
  if (r.n2 && !o.weights) {
  // chi-square is relevant only for situation (c)
    oss.str("");
    oss << r.chisq/(r.npts-1);
    s = oss.str();
    cout << setw(fw) << "  chi-square"                    << " = " << r.chisq << "\n"
         << setw(fw) << "  chi-square per deg of freedom" << " = " << s       << "\n"
         << setw(fw) << "  alpha"                         << " = " << r.alpha << "\n"
         << "\n"
            "    alpha is the probability that a larger\n"
            "    value of chi-square would be obtained for an\n"
            "    equivalent data set, assuming the data to be\n"
            "    drawn from a normal distribution.\n"
            "\n";
  }
  else {
    cout << "\n"
            "  No meaningful values of either chi-square or its associated\n"
            "  probability alpha are available for this case.\n"
            "\n";
  }
}
