//
// prints a usage message on the screen
//
#include "meanvar.h"
#include "config.h"

void prn_usage(char** argv)
{
  string pgname = basename(argv[0]);                 // chops long pathname

  if (pgname.rfind(".exe") != string::npos) {
    pgname.replace(pgname.find(".exe"),4,"");
  }

  #ifdef WINCMD // windows' cmd.exe does not honor bold type
  cout <<
    "\n Usage: " << pgname <<
    " [--help]"
    " [--version]"
    " [--weights]"
    " [--ignore_s]\n"
    "                [--conf n]"
    " datafile\n";
  cout <<
    " Single letter options (-h, -v, -w, -i, -c n)"
    " are available.\n\n";
  #else
  cout <<
    "\n Usage: \033[1m" << pgname << "\033[0m"
    " [--help]"
    " [--version]"
    " [--weights]"
    " [--ignore_s]\n"
    "                [--conf \033[1mn\033[0m]"
    " \033[1mdatafile\033[0m\n";
  cout <<
    " Single letter options (-h, -v, -w, -i, -c \033[1mn\033[0m)"
    " are available.\n\n";
  #endif
}

